﻿package {
	
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.Shape;
	import flash.text.TextFormat;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.Font;
	import gs.*;
	import com.tutsplus.active.util.Align;
	
	public class ScrollBox extends Sprite {
		
		private var _container:Sprite;
		private var _item:Item;
		private var _itemTextField:TextField;
		private var _defaultFormat:TextFormat = new TextFormat();
		private var _arialRounded:Font = new ArialRounded();
		private var _textFieldXPosition:uint = 10;
		private var _textFieldYPosition:uint = 13;
		private var _textFieldWidth:uint = 240;
		private var _textFieldHeight:uint = 25;
		private var _itemPosition:uint = 49;		
		private var _mask:Shape;
		private var _maskWidth:uint = 288;
		private var _maskHeight:uint = 290;
		private var _paddingTop:uint = 120;
		private var _background:Shape;		
		private var _maxSpeed:uint = 15;
		private var _speed:Number;		
		private var _items:XMLList;
		private var _stage:Stage;
		public var scrollModel:ScrollModel;
		
		public function ScrollBox (stage:Stage, m:ScrollModel) {
			this.scrollModel = m;
			this._stage = stage;
			scrollModel.addEventListener(ScrollModel.MODEL_UPDATE, createRollingScroller);
		}
		
		
		private function createRollingScroller(event:Event = null):void {		
			_container = new Sprite();
			_stage.addChild(_container);
			
			_items = scrollModel.items;
			for (var i = 0; i < _items.length(); i++) {
				_item = new Item();
				_item.item_btn_over.alpha = 0;
				
				_itemTextField = new TextField();
				_itemTextField.x = _textFieldXPosition;
				_itemTextField.y = _textFieldYPosition;
				_itemTextField.selectable = false;
				_itemTextField.width = _textFieldWidth;
				_itemTextField.height = _textFieldHeight; 
				_itemTextField.embedFonts = true;
				
				_defaultFormat.color = 0x111112;
				_defaultFormat.font = _arialRounded.fontName;
				_defaultFormat.size = 18;
				_itemTextField.defaultTextFormat = _defaultFormat;
				_itemTextField.text = _items[i].toString();
				
				_item.addChild(_itemTextField);
				_item.y = i * _itemPosition;
				_item.buttonMode = true;
				_item.mouseChildren = false;
				_container.addChild(_item);
			}
			
			_background = new Shape();
			_background.graphics.beginFill(0xFFFFFF);
			_background.graphics.drawRect(0, 0, _container.width, _container.height);
			_background.graphics.endFill();
			_container.addChildAt(_background, 0);
			
			_mask = new Shape();
			_mask.graphics.beginFill(0xFF0000);
			_mask.graphics.drawRect(0, 0, _maskWidth, _maskHeight);
			_mask.graphics.endFill();
			Align.centerHorizontallyInStage(_stage, _mask);	
			_mask.y = _paddingTop;
			addChild(_mask);
			
			_container.mask = _mask;

			Align.centerHorizontallyInStage(_stage, _container);	
			_container.y = _paddingTop;
			
			_container.addEventListener(MouseEvent.MOUSE_OVER, movingOver);
			_container.addEventListener(MouseEvent.MOUSE_OUT, movingOut);
			
			
		}
		
		private function movingOver (event:MouseEvent):void {
			_container.removeEventListener(MouseEvent.MOUSE_OVER, movingOver);
			addEventListener(Event.ENTER_FRAME, enterFrame);
			if (event.target is Item) 
				TweenMax.to(Item(event.target).item_btn_over, .2, {alpha:1});
		}
		
		private function movingOut (event:MouseEvent):void {
			removeEventListener(Event.ENTER_FRAME, enterFrame);
			_container.addEventListener(MouseEvent.MOUSE_OVER, movingOver);				
			if (event.target is Item)
				TweenMax.to(Item(event.target).item_btn_over, .2, {alpha:0});
		}
		
		
		function enterFrame(event:Event):void {
			_speed = (_mask.height / 2 - _mask.mouseY) / (_mask.height / 2) * _maxSpeed;
			_container.y += _speed;
			if (_container.y >= _paddingTop) {
				removeEventListener(Event.ENTER_FRAME, enterFrame);
				_container.y = _paddingTop;
			}
			if (_container.y <= _mask.height - _container.height + _paddingTop) {
				removeEventListener(Event.ENTER_FRAME, enterFrame);
				_container.y = _mask.height - _container.height + _paddingTop;
			}
		}
		
	}	
}
	
	
	
	